/************************************************************ 
The contents of this file are subject to the Pumpkin Salvo
License (the "License").  You may not use this file except
in compliance with the License. You may obtain a copy of
the License at http://www.pumpkininc.com, or from
warranty@pumpkininc.com.

Software distributed under the License is distributed on an
"AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
or implied. See the License for specific language governing
the warranty and the rights and limitations under the
License.

The Original Code is Salvo - The RTOS that runs in tiny
places(TM). Copyright (C) 1995-2002 Pumpkin, Inc. and its
Licensor(s). All Rights Reserved.

$Source: C:\\RCS\\d\\salvo\\inc\\portht51.h,v $
$Author: aek $
$Revision: 3.5 $
$Date: 2002-12-06 17:42:32-08 $

Porting file for 8051-type micros and HI-TECH 8051C.

************************************************************/

#if OSMAKE_LIBRARY
#include <8051.h>
#endif

#include <stdio.h>
#include <string.h>
#include <intrpt.h>
#include <stdarg.h>
#include <stdlib.h>


/* use our own. */
#if !defined(OSDi)
#define OSDi()                          EA = 0
#endif
#if !defined(OSEi)
#define OSEi()                          EA = 1
#endif
                                        
 
/* should work fine. */
#define OSUSE_MEMSET                    TRUE


/************************************************************ 
****                                                     ****
**                                                         **
Notes 

1. 8051C in the small and medium models only allows multiple 
callgraphs if all parameters and auto variables can fit in 
registers. Large model uses a stack. Therefore protection 
is not required.

2. Bitfields are 16-bit and cannot be changed.

3. Easiest compilation is with data and pointer types set
to their defaults.

4. Void pointers for messages are fine.

5. Standard function pointers are fine.

6. OSCtxSw() is in port8051.c.

**                                                         **
****                                                     ****
************************************************************/
