/*                                                          */                                                                
/* ===================== PICmicro ========================= */
/*                                                          */                                                                
#if   defined(SYSA) || defined(SYSE) || defined(SYSF) \
  ||  defined(SYSH) || defined(SYSP)

#define TMR0_RELOAD		156     /* for 100Hz ints @ 4MHz */

#if defined(SYSF)				/* PICC-18 uses different nomenclature */
#define T0IF			TMR0IF
#define T0IE			TMR0IE
#endif

#if defined(SYSP)
#define TMR0			TMR0L
#endif

/*                                                          */                                                                
/* ======================= 8051 =========================== */
/*                                                          */                                                                
#elif defined(SYSI) /* Keil Cx51     */ \
   || defined(SYSM) /* HI-TECH 8051C */ \
   || defined(SYSN) /* Tasking C51   */ 
   
#if   defined(SYSI)
#include <reg51.h>  /* for generic 8051 */
#elif defined(SYSM)
#include <8051.h>   /* for generic 8051 */
#elif defined(SYSN)
#error main.h: Not supported.
#endif


/*                                                          */                                                                
/* ====================== MSP430 ========================== */
/*                                                          */                                                                
#elif defined(SYSQ) /* IAR MSP430 C              */ \
   || defined(SYSR) /* Archelon Quadravox AQ430  */ \
   || defined(SYSS) /* ImageCraft ICC430         */ \
   || defined(SYSX) /* Rowley CrossStudio MSP430 */

#if   defined(SYSQ)
#include <msp430x14x.h> /* for MSP430F149 */
#elif defined(SYSR)
#include <msp430x14x.h> /* for MSP430F149 */
#elif defined(SYSS)
#include <msp430x14x.h> /* for MSP430F149 */
#elif defined(SYSX)
#endif


/*                                                          */                                                                
/* ======================= AVR ============================ */
/*                                                          */                                                                
#elif   defined(SYSV)
#include <io8515v.h> /* for AT90S8515 */


/*                                                          */                                                                
/* ===================== TMS320C24x ======================= */
/*                                                          */                                                                
#elif   defined(SYSAA)
#include <f2407_c.h> /* need peripheral definitions */


#endif
